package cn.ibizlab.codegen.model;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.Accessors;
import net.ibizsys.model.app.IPSApplication;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@Accessors(chain = true)
public class AppModel extends BaseModel{

    public AppModel(IPSApplication application)
    {
        this.opt=application;
        this.setCodeName(application.getCodeName());
        this.setName(application.getName());
        appEntities=new ArrayList<>();
        if(getApplication().getAllPSAppDataEntities()!=null)
        {
            getApplication().getAllPSAppDataEntities().forEach(item->{
                appEntities.add(new AppEntityModel(this,item));
            });
        }
        pages=new ArrayList<>();
        if(getApplication().getAllPSAppViews()!=null)
        {
            getApplication().getAllPSAppViews().forEach(item->{
                pages.add(new PageModel(this,item));
            });
        }
    }

    private List<AppEntityModel> appEntities;


    private List<PageModel> pages;

    public IPSApplication getApplication()
    {
        return (IPSApplication)opt;
    }


}
