package cn.ibizlab.codegen.model;

import cn.ibizlab.codegen.templating.TemplateFileType;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.experimental.Accessors;
import net.ibizsys.model.IPSSystem;
import net.ibizsys.model.database.IPSDEFDTColumn;
import net.ibizsys.model.dataentity.IPSDataEntity;
import net.ibizsys.model.dataentity.defield.IPSDEField;
import net.ibizsys.model.dataentity.defield.IPSLinkDEField;
import net.ibizsys.model.dataentity.der.IPSDER1N;
import net.ibizsys.model.dataentity.der.IPSDERBase;
import net.ibizsys.model.dataentity.ds.IPSDEDataQueryCode;
import net.ibizsys.model.dataentity.ds.IPSDEDataQueryCodeCond;
import net.ibizsys.model.dataentity.ds.IPSDEDataSetGroupParam;
import net.ibizsys.model.dataentity.ds.PSDEDataSetGroupParamImpl;
import org.springframework.util.Assert;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;

import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

@Getter
@Setter
@NoArgsConstructor
@Accessors(chain = true)
public class SystemModel extends BaseModel {

    public SystemModel(IPSSystem system)
    {
        this.opt=system;
    }

    public IPSSystem getSystem()
    {
        return (IPSSystem)opt;
    }

    public String getProjectName()
    {
        return  getSystem().getCodeName().toLowerCase();
    }

    public String getProjectDesc()
    {
        return  getSystem().getName();
    }

    public String getPackageName()
    {
        return getSystem().getCodeName().toLowerCase();
    }

    private List<EntityModel> entities;
    public List<EntityModel> getEntities(){
        if(entities==null) {
            entities = new ArrayList<>();
            getSystem().getAllPSDataEntities().forEach(dataEntity -> {
                entities.add(new EntityModel(dataEntity));
            });
        }
        return entities;
    }

    private List<AppModel> apps;
    public List<AppModel> getApps()
    {
        if(apps==null)
        {
            apps=new ArrayList<>();
            if(getSystem().getAllPSApps()!=null) {
                getSystem().getAllPSApps().forEach(item -> {
                    apps.add(new AppModel(item));
                });
            }
        }
        return apps;
    }

    private List<ApiModel> apis;
    public List<ApiModel> getApis()
    {
        if(apis==null)
        {
            apis=new ArrayList<>();
            getSystem().getAllPSSysServiceAPIs().forEach(api->{
                 apis.add(new ApiModel(api));
            });
        }
        return apis;
    }





}
